// JavaScript Document
function update(activeAnchor){
	var group = activeAnchor.getParent();
	// part superior de les figures grup
	var topLeft = group.find('.topLeft')[0];
	var topRight = group.find('.topRight')[0];
	// part inferior de les figures grup
	var bottomRight = group.find('.bottomRight')[0];
	var bottomLeft= group.find('.bottomLeft')[0];
	var image = group.find('.image')[0];
	var anchorX = activeAnchor.x();
	var anchorY = activeAnchor.y();
	
	//casos de les diferents possibilitats de la variable activeAnchor
	// utilitzacio del condicional switch
	switch (activeAnchor.name()){
		case 'topLeft':
			topRight.y(anchorY);
			bottomLeft.x(anchorX);
			break;
		case 'topRight': 
			topLeft.y(anchorY);
			bottomRight.x(anchorX);
			break;
		case 'bottomRight':
			bottomLeft.y(anchorY);
			topRight.x(anchorX);
			break;
		case 'bottomLeft':
			bottomRight.y(anchorY);
			topLeft.x(anchorX);
			break;
	}
	image.setPosition(topLeft.getPosition());
	var width = topRight.x() - topLeft.x();
	var height = bottomLeft.y() - topLeft.y();
	if (width && height){
		image.setSize({width:width, height:height});
	}
}
function addAnchor(group, x, y, name){
	var stage = group.getStage();
	var layer = group.getLayer();
	
	var anchor = new Kinetic.Circle({
		x:x,
		y: y,
		stroke: '#003333',
		fill: '#fff',
		strokeWidth:3,
		radius:4,
		name: name,
		draggable:true,
		dragOnTop:false
		
	});
	anchor.on('dragmove', function(){
		update(this);
		layer.draw();
	});
	anchor.on('mousedown touchstart', function(){
		group.setDraggable(false);
		this.moveToTop();
	});
	anchor.on('dragend', function(){
		group.setDraggable(true);
		layer.draw();
	});
	//canviar la forma del punter del ratolí
	anchor.on('mouseover', function(){
		var layer = this.getLayer();
		document.body.style.cursor ='pointer';
		this.serStrokeWidth(5);
		layer.draw();
	});
	anchor.on('mouseout', function(){
		var layer = this.getLayer();
		document.body.style.cursor = 'default';
		this.setStrokeWidth(3);
		layer.draw();
	});
	group.add(anchor);
}

function loadImages(sources, callback) {
        var images = {};
        var loadedImages = 0;
        var numImages = 0;
        // agafa les diferents fonts
        for(var src in sources) {
          numImages++; 
        }
        for(var src in sources) {
          images[src] = new Image();
          images[src].onload = function() {
            if(++loadedImages >= numImages) {
              callback(images);
            }
          };
 		 images[src].src = sources[src];
        }
      }
      function initStage(images) {
        var stage = new Kinetic.Stage({
          container: 'container',
          width: 300,
          height: 400
        });
		//creacio del grups que serviran per unir els components
		var unioGroup = new Kinetic.Group({
			x:80,
			y:310,
			draggable:true
		});
		
		var unionsGroup = new Kinetic.Group({
			x:100,
			y:300,
			draggable:true
		});
		var unGroup = new Kinetic.Group({
			x:120,
			y:310,
			draggable:true
		});
		var dobleGroup = new Kinetic.Group({
			x:200,
			y:330,
			draggable:true
		});
		var horitzontalGroup = new Kinetic.Group({
			x:250,
			y:310,
			draggable:true
		});
		var horitzoGroup = new Kinetic.Group({
			x:190,
			y:310,
			draggable:true
		});
        var layer = new Kinetic.Layer();
		// variables de grup en una capa
		layer.add(unioGroup);
		layer.add(unionsGroup);
		layer.add(unGroup);
		layer.add(dobleGroup);
		layer.add(horitzontalGroup);
		layer.add(horitzoGroup);
		stage.add(layer);
		// unioGroup format per:
		var conectaImg = new Kinetic.Image({
			x:0,
			y:0,
			image: images.conectorv,
			width:3,
			height:40,
			name:'image'
		});
		unioGroup.add(conectaImg);
		
		addAnchor(unioGroup, 0,0,'topLeft');
		addAnchor(unioGroup, 3,0,'topRight');
		addAnchor(unioGroup, 3,40,'bottomRight');
		addAnchor(unioGroup, 0,40,'bottomLeft');
		unioGroup.on('dragstart', function(){
			this.moveToTop();
		});
		var conectImg = new Kinetic.Image({
			x:0,
			y:0,
			image: images.conectorv,
			width:3,
			height:50,
			name:'image'
		});
		unionsGroup.add(conectImg);
		addAnchor(unionsGroup, 0,0,'topLeft');
		addAnchor(unionsGroup, 3,0,'topRight');
		addAnchor(unionsGroup, 3,50,'bottomRight');
		addAnchor(unionsGroup, 0,50,'bottomLeft');
		unionsGroup.on('dragstart', function(){
			this.moveToTop();
		});
		var coneImg = new Kinetic.Image({
			x:0,
			y:0,
			image: images.conectorv,
			width:3,
			height:40,
			name:'image'
		});
		unGroup.add(coneImg);
		addAnchor(unGroup, 0,0,'topLeft');
		addAnchor(unGroup, 3,0,'topRight');
		addAnchor(unGroup, 3,40,'bottomRight');
		addAnchor(unGroup, 0,40,'bottomLeft');
		unGroup.on('dragstart', function(){
			this.moveToTop();
		});
	   var conecImg = new Kinetic.Image({
		   x:0,
		   y:0,
		   image: images.conectorh,
		   width:40,
		   height:3,
		   name:'image'
	   });
	   dobleGroup.add(conecImg);
	   addAnchor(dobleGroup,0,0, 'topLeft');
	   addAnchor(dobleGroup, 40,0, 'topRight');
	   addAnchor(dobleGroup, 40,3,'bottomRight');
	   addAnchor(dobleGroup, 0, 3, 'bottomLeft');
	   dobleGroup.on('dragstart', function(){
		   this.moveToTop();
	   });
	   
	   var horitImg = new Kinetic.Image({
		   x:0,
		   y:0,
		   image: images.conectorh,
		   width:40,
		   height:3,
		   name:'image'
	   });
	   horitzontalGroup.add(horitImg);
	   addAnchor(horitzontalGroup,0,0, 'topLeft');
	   addAnchor(horitzontalGroup, 40,0, 'topRight');
	   addAnchor(horitzontalGroup, 40,3,'bottomRight');
	   addAnchor(horitzontalGroup, 0, 3, 'bottomLeft');
	    horitzontalGroup.on('dragstart', function(){
		   this.moveToTop();
	   });
	   
	   var planaImg= new Kinetic.Image({
		  x:0,
		  y:0,
		  image: images.conectorh,
		   width:40,
		   height:3,
		   name:'image'
	   });
	   horitzoGroup.add(planaImg);
	   addAnchor(horitzoGroup,0,0, 'topLeft');
	   addAnchor(horitzoGroup, 40,0, 'topRight');
	   addAnchor(horitzoGroup, 40,3,'bottomRight');
	   addAnchor(horitzoGroup, 0, 3, 'bottomLeft');
	    horitzoGroup.on('dragstart', function(){
		   this.moveToTop(); 
	   });
        // bateria vertical
        var bateriaImg = new Kinetic.Image({
          image: images.bateria,
          x: 3,
	      y: 350,
          width: 30,
          height: 58,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });

        layer.add(bateriaImg).add(bateriaImg.clone());
		
		//bateria horitzontal
		  var bateriahImg = new Kinetic.Image({
          image: images.bateriah,
          x:250,
	      y: 375,
          width: 58,
          height: 30,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });

        layer.add(bateriahImg).add(bateriahImg.clone());

        // interruptor horitzontal
        var interruptorImg = new Kinetic.Image({
          image: images.interruptor,
          x: 160,
          y: 380,
          width: 50,
          height: 17,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });

        layer.add(interruptorImg).add(interruptorImg.clone()).add(interruptorImg.clone());
		
		//interruptor vertical
		  var interruptorvImg = new Kinetic.Image({
          image: images.interruptorv,
          x: 40,
          y: 350,
          width: 20,
          height: 50,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });

        layer.add(interruptorvImg).add(interruptorvImg.clone()).add(interruptorvImg.clone());
						
		//bombeta horitzontal
		 var bombetaImg = new Kinetic.Image({
          image: images.bombeta,
          x:212,
          y: 380,
          width: 35,
          height:20,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });

        layer.add(bombetaImg).add(bombetaImg.clone()).add(bombetaImg.clone()).add(bombetaImg.clone()).add(bombetaImg.clone());
		
		//bombeta vertical
		 var bombetavImg = new Kinetic.Image({
          image: images.bombetav,
          x: 62,
          y: 370,
          width: 20,
          height:35,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(bombetavImg).add(bombetavImg.clone()).add(bombetavImg.clone()).add(bombetavImg.clone()).add(bombetavImg.clone());
		
		//pulsadors en les diferents possibilitats
		var pulsadorImg = new Kinetic.Image({
          image: images.pulsador,
          x:160,
          y: 350,
          width: 30,
          height:25,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(pulsadorImg).add(pulsadorImg.clone()).add(pulsadorImg.clone());
		
		var pulsadorvImg = new Kinetic.Image({
          image: images.pulsadorv,
          x: 82,
          y: 370,
          width: 25,
          height:30,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(pulsadorvImg).add(pulsadorvImg.clone()).add(pulsadorvImg.clone());
		
		//pulsadors normalment tancats horitzontal
		var pulsadoronImg = new Kinetic.Image({
          image: images.pulsadoron,
          x:190,
          y: 350,
          width: 50,
          height:25,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(pulsadoronImg).add(pulsadoronImg.clone()).add(pulsadoronImg.clone());
		
		//pulsador normalment tancat vertical
		var pulsadoronvImg = new Kinetic.Image({
          image: images.pulsadoronv,
          x:110,
          y: 360,
          width: 25,
          height:40,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(pulsadoronvImg).add(pulsadoronvImg.clone()).add(pulsadoronvImg.clone());
		
		//motor horitzontal
		var motorImg = new Kinetic.Image({
          image: images.motor,
          x:244,
          y: 350,
          width: 42,
          height:29,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(motorImg).add(motorImg.clone()).add(motorImg.clone()).add(motorImg.clone()).add(motorImg.clone());
		
		//motor vertical
		var motorvImg = new Kinetic.Image({
          image: images.motorv,
          x:3,
          y: 305,
          width: 29,
          height:42,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(motorvImg).add(motorvImg.clone()).add(motorvImg.clone()).add(motorvImg.clone()).add(motorvImg.clone());
		
		//zumbador horitzontal
		var zumbadorImg = new Kinetic.Image({
          image: images.zumbador,
          x:275,
          y: 330,
          width: 26,
          height:22,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(zumbadorImg).add(zumbadorImg.clone()).add(zumbadorImg.clone()).add(zumbadorImg.clone()).add(zumbadorImg.clone());
		
		//zumbador vertical
		var zumbadorvImg = new Kinetic.Image({
          image: images.zumbadorv,
          x:35,
          y: 320,
          width: 22,
          height:26,
          draggable: true,
          stroke: 'red',
          strokeWidth: 10,
          strokeEnabled: false
        });
		layer.add(zumbadorvImg).add(zumbadorvImg.clone()).add(zumbadorvImg.clone()).add(zumbadorvImg.clone()).add(zumbadorvImg.clone());
		
        stage.add(layer);

        // use event delegation to update pointer style
        // and apply borders
        layer.on('mouseover', function(evt) {
          var shape = evt.shape;
document.body.style.cursor = 'pointer'; 
          shape.enableStroke();
          layer.draw();
        });
        layer.on('mouseout', function(evt) {
          var shape = evt.shape;
          document.body.style.cursor = 'default';  
          shape.disableStroke();
          layer.draw();
        });
		stage.draw();
      }
      var sources = {
       bateria: 'imatges/bateria.png',
       interruptor: 'imatges/interruptor.png',
	    bombeta:'imatges/bombeta.png',
	   bombetav:'imatges/bombetav.png',
	   pulsador:'imatges/pulsador.png',
	   interruptorv:'imatges/interruptorv.png',
	   pulsadorv:'imatges/pulsadorv.png',
	   bateriah:'imatges/bateriah.png',
	   pulsadoron:'imatges/pulsadoron.png',
	   pulsadoronv:'imatges/pulsadoronv.png',
	   motor:'imatges/motor.png',
	   motorv:'imatges/motorv.png',
	   zumbador:'imatges/zumbador.png',
	   zumbadorv:'imatges/zumbadorv.png',
	   conectorv:'imatges/conectorh.png',
	   conectorh: 'imatges/conectorv.png'
	   
	   
      };
      loadImages(sources, initStage);
	